Subject: Re: bug#4599: 23.1.50; VC (CVS) fails to show directory status

From: Stefan Monnier <[email-masked]>
Date: Wed, 30 Sep 2009 15:59:18 -0400

> +2009-09-29  Stefan Monnier  <address@hidden>
> +
> +       * vc-hooks.el (vc-dir-buffers): New var.
> +       (vc-state-refresh): New function.
> +       (vc-state): Use it.
> +       (vc-after-save): Always ask the backend to recompute the new state.
> +       Always call vc-dir if necessary, using vc-dir-buffers.
> +       * vc-dir.el (vc-dir-prepare-status-buffer, vc-dir-resynch-file):
> +       Use vc-dir-buffers.
> +       (vc-dir-mode): Use vc-dir-buffers rather than after-save-hook.
> +       (vc-dir-prepare-status-buffer, vc-dir-update)
> +       (vc-dir-resync-directory-files, vc-dir-resynch-file, vc-dir-mode):
> +       Don't call expand-file-name on default-directory.

> in particular the removal or the expand-file-name calls is incorrect.
> At least ~ needs to be expanded, otherwise things just do not work.

While it might be the immediate cause of the problem, I think the
removal of expand-file-name calls might still be right: the code that
sets default-directory to a value starting with "~/" might be the one
that should be changed.

        Stefan